import java.lang.*;
import java.awt.*;
import fr.l2f.gui.*;

public class  jsammon extends Frame
{
  static jsammon js;
  public JScanvas jc;
  Button dismissButton,iterateButton,zoomin,zoomout,auto;
  Button up,down,left,right;
  public TextField r1,r2,iterate1,iterate2,niterations;
  int itsofar;
  double saerror;
  static public HiPointDataset dataset;
  static Cursor defaultcursor,waitcursor;
  jsammon()
    {
       Panel p,p2,p3;
       itsofar=0;
       saerror=0;
       jc=new JScanvas(this);
       add("Center",jc);
       p=new  Panel();
       p2=new Panel();
       p.setLayout(new  GridLayout(0,1));
       p2.setLayout(new GridLayout(0,1));
       dismissButton=new Button("Dismiss");
       p2.add(dismissButton);
       p2.add(new Label());
       p2.add(new Label("Zoom control"));
       p3=new Panel();
       zoomin=new Button("+");
       zoomout=new Button("-");
       auto=new Button("(Re)AutoScale");
       p3.add(zoomin);
       p3.add(zoomout);
       p3.add(auto);
       p2.add(p3);
       p2.add(new Label());
       p2.add(new Label("Scroll control"));
       p3=new Panel();
       up=new Button("Up"); 
       down=new Button("Down");
       left=new Button("Left");
       right=new Button("Right");
       p3.add(up);
       p3.add(down);
       p3.add(left);
       p3.add(right);
       p2.add(p3);
       p2.add(new Label());
       iterateButton=new Button("Iterate Sammon's algorithm");
       p2.add(iterateButton);
       p3=new Panel();
       niterations=new TextField(10); niterations.setText("1");
       p3.add(niterations);
       p3.add(new Label(" times"));
       p2.add(p3);
       iterate1=new TextField(30); iterate1.setEditable(false);
       iterate1.setText("Iterations so far: 0");
       iterate2=new TextField(30); iterate2.setEditable(false);
       iterate2.setText("Error: undefined");
       p2.add(iterate1);
       p2.add(iterate2);
       r1=new  TextField(80); r1.setEditable(false);
       r2=new  TextField(80); r2.setEditable(false);
       p.add(r1);
       p.add(r2);
       add("South",p);
       add("West",p2);
       setTitle("Sammon's view");
       pack();
    }
    public boolean action(Event event, Object object)
    {
        if (event.target == dismissButton)
            System.exit(0);
        if (event.target == iterateButton)
           {
             int k;
             for(k=0; k<Integer.valueOf(niterations.getText()).intValue(); k++)
               {
	         setCursor(waitcursor);
                 itsofar++;
                 saerror=dataset.iterate_sammon(iterate1,iterate2,r1,r2);
                 jc.repaint();
                 iterate1.setText("Iterations so far: "+itsofar);
                 iterate2.setText("Error: "+saerror);
	         setCursor(defaultcursor);
               }
             return true;
           }
        if (event.target == zoomin) { jc.zoom(0.8); return true;}
        if (event.target == zoomout) { jc.zoom(1.25); return true;}
        if (event.target == auto) {jc.autoscale(); jc.repaint(); return true;}
        if (event.target == up) { jc.scroll(0,0.25); return true;}
        if (event.target == down) { jc.scroll(0,-0.25); return true;}
        if (event.target == left) { jc.scroll(-0.25,0); return true;}
        if (event.target == right) { jc.scroll(0.25,0); return true;}
        return false;
    }
    public boolean handleEvent(Event event)
    {
        if (event.id ==  Event.WINDOW_DESTROY)
            System.exit(0);
        return super.handleEvent(event);
    }

  public static void main(String[]args)
    {
      if(args.length<1)
        {
          System.err.println("usage: java jsammon datafile");
          System.exit(1);
        }
      try  
        {
          dataset=new HiPointDataset(args[0]);
        } 
      catch(Exception e) 
       {
         System.err.println("Exception "+e+" while loading file "+args[0]);
         System.exit(2);
       }
      defaultcursor=new Cursor(Cursor.DEFAULT_CURSOR);
      waitcursor=new Cursor(Cursor.WAIT_CURSOR);
      js=new jsammon();
      js.show();
    }
}
